//  hwdeint.cpp
//
//  hwdeint main
//
//	Copyright (c) 2005 N099
//
#include <streams.h>     // DirectShow (includes windows.h)
#include <dvdmedia.h>
#include <initguid.h>    // declares DEFINE_GUID to declare an EXTERN_C const.
#include <aviriff.h> 

#include <vector>
#include <string>
#include <algorithm>

#include "hwdeintuids.h"
#include "hwdeintdefs.h"
#include "hwdeint.h"
#include "hwdeintprop.h"
#include "prop_color.h"
#include "prop_dsf.h"
#include "util.h"

using namespace std;

#define IsEnable(x,y) (((x)&(y)) == 0 ? 0 : 1)


//Factory Template
static WCHAR g_wszName[] = L"HW Deinterlace Filter";
CFactoryTemplate g_Templates[] = 
{
  { 
    g_wszName,
    &CLSID_HWDeint,
    CHWDeintFilter::CreateInstance,
    NULL,
    NULL
  },
  {
	L"HWDeint Configuration",
    &CLSID_HWDeintProp,
	CHWDeintProp::CreateInstance, 
	NULL,
	NULL
  },
  {
	L"Color format Configuration",
    &CLSID_HWDeintProp_Color,
	CHWDeintProp_Color::CreateInstance, 
	NULL,
	NULL
  },
  {
	L"DS Filter Configuration",
    &CLSID_HWDeintProp_DSF,
	CHWDeintProp_DSF::CreateInstance, 
	NULL,
	NULL
  }
};

int g_cTemplates = sizeof(g_Templates) / sizeof(g_Templates[0]);



extern "C" BOOL WINAPI DllEntryPoint(HINSTANCE, ULONG, LPVOID);

BOOL APIENTRY DllMain( HANDLE hModule,
					   DWORD dwReason,
					   LPVOID lpReserved
					 )
{
	return DllEntryPoint((HINSTANCE)(hModule), dwReason, lpReserved);
}

// tB^o^
// fBA ^Cv錾B
REGPINTYPES sudInputTypes = { &MEDIATYPE_Video, &GUID_NULL };
REGPINTYPES sudOutputTypes = { &MEDIATYPE_Video, &GUID_NULL };


// s錾B
REGFILTERPINS sudPinReg[] = {
    // ̓sB
    { 0, FALSE, // Rendered?
         FALSE, // Output?
         FALSE, // Zero?
         FALSE, // Many?
         0, 0, 
         1, &sudInputTypes  // Media types.
    },
    // o̓sB
    { 0, FALSE, // _OĂ邩?
         TRUE, // o?
         FALSE, // [?
         FALSE, // ?
         0, 0, 
         1, &sudOutputTypes      // fBA ^CvB
    }
};
 
// tB^錾B
REGFILTER2 rf2FilterReg = {
    1,                // o[WԍB
    MERIT_DO_NOT_USE, // bgB
    2,                // s̐B
    sudPinReg         // sւ̃|C^B
};


STDAPI DllRegisterServer(void)
{
    HRESULT hr = AMovieDllRegisterServer2(TRUE);
    if (FAILED(hr))
    {
        return hr;
    }
    IFilterMapper2 *pFM2 = NULL;
    hr = CoCreateInstance(CLSID_FilterMapper2, NULL, CLSCTX_INPROC_SERVER,
            IID_IFilterMapper2, (void **)&pFM2);
    if (SUCCEEDED(hr))
    {
        hr = pFM2->RegisterFilter(
            CLSID_HWDeint,                // tB^ CLSIDB
            g_wszName,                       // tB^B
            NULL,                            // foCX jJB
            &CLSID_LegacyAmFilterCategory,   // DSF JeSB
            NULL,                       // CX^X f[^B
            &rf2FilterReg                    // tB^B
            );
        pFM2->Release();
    }
    return hr;
}

STDAPI DllUnregisterServer()
{
    HRESULT hr = AMovieDllRegisterServer2(FALSE);
    if (FAILED(hr))
    {
        return hr;
    }
    IFilterMapper2 *pFM2 = NULL;
    hr = CoCreateInstance(CLSID_FilterMapper2, NULL, CLSCTX_INPROC_SERVER,
            IID_IFilterMapper2, (void **)&pFM2);
    if (SUCCEEDED(hr))
    {
        hr = pFM2->UnregisterFilter(&CLSID_LegacyAmFilterCategory, 
            NULL, CLSID_HWDeint);
        pFM2->Release();
    }
    return hr;
}


/* create instance */

CUnknown * WINAPI CHWDeintFilter::CreateInstance(LPUNKNOWN punk, HRESULT *phr)
{
    CHWDeintFilter * pNewObject = new CHWDeintFilter(punk, phr);
    if (pNewObject == NULL)
	{
        *phr = E_OUTOFMEMORY;
    }
    return pNewObject;
}

/* query interfaces */

STDMETHODIMP CHWDeintFilter::NonDelegatingQueryInterface(REFIID riid, void **ppv)
{
	CheckPointer(ppv, E_POINTER);

	if (riid == IID_ISpecifyPropertyPages)
	{
        return GetInterface(static_cast<ISpecifyPropertyPages*>(this), ppv); 
	} 
	if (riid == IID_IHWDeint) {
        return GetInterface(static_cast<IHWDeint*>(this), ppv);
    }
	
	return CBaseFilter::NonDelegatingQueryInterface(riid, ppv);
}

/* get property page list */

STDMETHODIMP CHWDeintFilter::GetPages(CAUUID * pPages)
{
	if (pPages == NULL) return E_POINTER;
	pPages->cElems = 3;
	pPages->pElems = (GUID *)CoTaskMemAlloc(pPages->cElems * sizeof(GUID));
	if (pPages->pElems == NULL)
	{
		return E_OUTOFMEMORY;
	}
	pPages->pElems[0] = CLSID_HWDeintProp;
	pPages->pElems[1] = CLSID_HWDeintProp_Color;
	pPages->pElems[2] = CLSID_HWDeintProp_DSF;

	return S_OK;
}


/* cleanup pages */

STDMETHODIMP CHWDeintFilter::FreePages(CAUUID * pPages)
{
	CoTaskMemFree(pPages->pElems);
	return S_OK;
}


/* constructor */
CHWDeintFilter::CHWDeintFilter(LPUNKNOWN punk, HRESULT *phr)
 : CTransInPlaceFilter2(NAME("HW Deinterlace filter"), punk, CLSID_HWDeint, phr, false)
{
	LoadRegistryInfo(&m_conf);
	LoadDSFlist(m_dsflist);
	m_pTi = new TrayIcon(this);

	if(m_conf.ar.ar_mode == AR_ORIG || m_conf.ar.ar_mode == AR_UD){
		m_ARflag = AR_STD;
	}else{
		m_ARflag = AR_CHG;
	}

	DbgSetModuleLevel(LOG_ERROR|LOG_MEMORY|LOG_TRACE,3);
	DbgLog((LOG_TRACE, 2, TEXT("CHWDeintFilter::CHWDeintFilter")));
}

/* destructor */
CHWDeintFilter::~CHWDeintFilter()
{
	SaveRegistryInfo(m_conf);
	delete m_pTi;

	DbgLog((LOG_TRACE, 2, TEXT("CHWDeintFilter::~CHWDeintFilter")));
}

//FOURCC util func
static bool IsRaw(DWORD fcc)
{
	switch (fcc)
	{
	case BI_RGB:
	case BI_BITFIELDS:
	case FCC('YUY2'):
	case FCC('UYVY'):
	case FCC('YVYU'):
	case FCC('YUYV'):
	case FCC('AYUV'):
	case FCC('Y211'):
	case FCC('Y41P'):
	case FCC('Y411'):
	case FCC('YVU9'):
	case FCC('I420'):
	case FCC('YV12'):
	case FCC('IYUV'):
	case FCC('NV12'):
	case FCC('NV21'):
	case FCC('IMC1'):
	case FCC('IMC2'):
	case FCC('IMC3'):
	case FCC('IMC4'):
		return true;
	default:
		break;
	}

	return false;
}
/* check input type */

HRESULT CHWDeintFilter::CheckInputType(const CMediaType *mtIn)
{
	BOOL all = FALSE;
	DWORD fcc = 0xffffffff;

	if(*mtIn->Type() != MEDIATYPE_Video){
		return VFW_E_TYPE_NOT_ACCEPTED;
	}
	
	if(m_conf.colorspace & TYPE_ALL) {
		all = TRUE;
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_RGB555 && m_conf.colorspace&TYPE_RGB555) {
		fcc = BI_RGB;
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_RGB565 && m_conf.colorspace&TYPE_RGB565) {
		fcc = BI_RGB;
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_RGB24 && m_conf.colorspace&TYPE_RGB24) {
		fcc = BI_RGB;
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_RGB32 && m_conf.colorspace&TYPE_RGB32) {
		fcc = BI_RGB;
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_ARGB32 && m_conf.colorspace&TYPE_ARGB32) {
		fcc = BI_RGB;
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_YUY2 && m_conf.colorspace&TYPE_YUY2) {
		fcc = FCC('YUY2');
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_UYVY && m_conf.colorspace&TYPE_UYVY) {
		fcc = FCC('UYVY');
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_YVYU && m_conf.colorspace&TYPE_YVYU) {
		fcc = FCC('YVYU');
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_YUYV && m_conf.colorspace&TYPE_YUYV) {
		fcc = FCC('YUYV');
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_AYUV && m_conf.colorspace&TYPE_AYUV) {
		fcc = FCC('AYUV');
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_Y211 && m_conf.colorspace&TYPE_Y211) {
		fcc = FCC('Y211');
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_Y41P && m_conf.colorspace&TYPE_Y41P) {
		fcc = FCC('Y41P');
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_Y411 && m_conf.colorspace&TYPE_Y411) {
		fcc = FCC('Y411');
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_YVU9 && m_conf.colorspace&TYPE_YVU9) {
		fcc = FCC('YVU9');
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_I420 && m_conf.colorspace&TYPE_I420) {
		fcc = FCC('I420');
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_YV12 && m_conf.colorspace&TYPE_YV12) {
		fcc = FCC('YV12');
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_IYUV && m_conf.colorspace&TYPE_IYUV) {
		fcc = FCC('IYUV');
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_NV12 && m_conf.colorspace&TYPE_NV12) {
		fcc = FCC('NV12');
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_NV21 && m_conf.colorspace&TYPE_NV21) {
		fcc = FCC('NV21');
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_IMC1 && m_conf.colorspace&TYPE_IMC1) {
		fcc = FCC('IMC1');
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_IMC2 && m_conf.colorspace&TYPE_IMC2) {
		fcc = FCC('IMC2');
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_IMC3 && m_conf.colorspace&TYPE_IMC3) {
		fcc = FCC('IMC3');
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_IMC4 && m_conf.colorspace&TYPE_IMC4) {
		fcc = FCC('IMC4');
	} else {
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	BITMAPINFOHEADER *pbmi = NULL;
	if (*mtIn->FormatType() == FORMAT_VideoInfo)
	{
		if(mtIn->cbFormat >= sizeof(VIDEOINFOHEADER))
			pbmi = &reinterpret_cast<VIDEOINFOHEADER*>(mtIn->Format())->bmiHeader;
	} else if (*mtIn->FormatType() == FORMAT_VideoInfo2) {
		if(mtIn->cbFormat >= sizeof(VIDEOINFOHEADER2)){
			if(reinterpret_cast<VIDEOINFOHEADER2*>(mtIn->Format())->dwInterlaceFlags
				&& m_conf.misc.not_connect_iflg && !m_pInput->IsConnected()){
				// not connect if interlace flags exists
				DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::CheckInputType iflg")));
				return VFW_E_TYPE_NOT_ACCEPTED;
			}
			pbmi = &reinterpret_cast<VIDEOINFOHEADER2*>(mtIn->Format())->bmiHeader;
		}
	}
	if(pbmi){ //valid VideoInfo
		if(all){ //ALL
			if(IsRaw(pbmi->biCompression)){
				DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::CheckInputType RAW")));
				return S_OK; // RAW
			}
		}
		else{
			if(fcc==BI_RGB){ // RGB
				if(pbmi->biCompression == BI_RGB || pbmi->biCompression == BI_BITFIELDS){
					DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::CheckInputType RGB")));
					return S_OK;
				}
			}
			if(pbmi->biCompression == fcc){
				DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::CheckInputType YUV")));
				return S_OK; //YUV
			}
		}
	}

	return VFW_E_TYPE_NOT_ACCEPTED;
}


/* get list of supported output colorspaces */

HRESULT CHWDeintFilter::GetMediaType(int iPosition, CMediaType *pMediaType)
{

	if (m_pInput->IsConnected() == FALSE)
	{
		return E_UNEXPECTED;
	}

    if (iPosition < 0)
    {
        return E_INVALIDARG;
    }

	HRESULT hr = S_OK;
	BOOL fetched = FALSE;
	int num = -1;
	IEnumMediaTypes *pEnum;
	IPin            *pPin;
	AM_MEDIA_TYPE   *pMT;

	hr = m_pInput->ConnectedTo(&pPin);
	if(S_OK == hr){
		hr = pPin->EnumMediaTypes(&pEnum);
		if(S_OK == hr){
			while(iPosition>num){
				hr = pEnum->Next(1, &pMT, 0);
				if(S_OK == hr){
					CMediaType ctmp(*pMT);
					if(S_OK == CheckInputType(&ctmp)){
						*pMediaType = *pMT;
						++num;
					}
					DeleteMediaType(pMT);
				}else{
					break;
				}
			}
			if(num == iPosition){
				if(pMediaType->formattype != FORMAT_VideoInfo 
					&& pMediaType->formattype != FORMAT_VideoInfo2)
				{ hr = E_UNEXPECTED; }

				if(pMediaType->formattype == FORMAT_VideoInfo){
					ConvertVideoInfoToVideoInfo2(pMediaType);
				}
				if (pMediaType->cbFormat >= sizeof(VIDEOINFOHEADER2)){
					AddVIF2Flag(pMediaType);
				}else
				{ hr = E_UNEXPECTED; }
				fetched = TRUE;
			}
			pEnum->Release();
		}
		pPin->Release();
	}
	if(fetched) return hr;

    return VFW_S_NO_MORE_ITEMS;
}


HRESULT CHWDeintFilter::AddVIF2Flag(CMediaType *pMediaType)
{
	if(*pMediaType->FormatType() != FORMAT_VideoInfo2)
		return E_FAIL;

	VIDEOINFOHEADER2 *pVih = 
		reinterpret_cast<VIDEOINFOHEADER2*>(pMediaType->pbFormat);

	return AddVIF2Flag(pVih);
}

HRESULT CHWDeintFilter::AddVIF2Flag(AM_MEDIA_TYPE *pMediaType)
{
	if(pMediaType->formattype != FORMAT_VideoInfo2)
		return E_FAIL;

	VIDEOINFOHEADER2 *pVih = 
		reinterpret_cast<VIDEOINFOHEADER2*>(pMediaType->pbFormat);

	return AddVIF2Flag(pVih);
}

//util
static bool IsRectValid(VIDEOINFOHEADER *pV)
{
	if(    pV->rcSource.bottom == pV->rcTarget.bottom
		&& pV->rcSource.left   == pV->rcTarget.left
		&& pV->rcSource.right  == pV->rcTarget.right
		&& pV->rcSource.top    == pV->rcTarget.top    )
	{
		if(pV->rcSource.right > 0 && pV->rcSource.bottom != 0)
			return true;
	}
	return false;
}

HRESULT CHWDeintFilter::AddVIF2Flag(VIDEOINFOHEADER2 *pVih)
{
	// pVih  VIDEOINFOHEADER o[ɃANZXB 
	//videoinfo2 flags
	if(m_conf.vif2.interlace){
		if(0 == m_conf.vif2.disp_mode){
			pVih->dwInterlaceFlags = AMINTERLACE_IsInterlaced | AMINTERLACE_DisplayModeBobOrWeave;
		}else if(1 == m_conf.vif2.disp_mode){
			pVih->dwInterlaceFlags = AMINTERLACE_IsInterlaced | AMINTERLACE_DisplayModeBobOnly;
		}else if(2 == m_conf.vif2.disp_mode){
			pVih->dwInterlaceFlags = AMINTERLACE_IsInterlaced | AMINTERLACE_DisplayModeWeaveOnly;
		}
		if(m_conf.vif2.vif_tff) pVih->dwInterlaceFlags |= AMINTERLACE_Field1First;

		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::AddVIF2Flag vif2.interlace")));
	}
	//Aspect ratio
	if(m_conf.ar.ar_mode == AR_ORIG && m_pInput->IsConnected()){
		AM_MEDIA_TYPE *pamt = CreateMediaType(&m_pInput->CurrentMediaType());
		if(pamt->formattype == FORMAT_VideoInfo){
			VIDEOINFOHEADER *pV = reinterpret_cast<VIDEOINFOHEADER*>(pamt->pbFormat);
			BITMAPINFOHEADER *pbmi = &pV->bmiHeader;
			if(IsRectValid(pV)){
				pVih->dwPictAspectRatioX = pV->rcTarget.right;
				pVih->dwPictAspectRatioY = abs(pV->rcTarget.bottom);
			}else{
				pVih->dwPictAspectRatioX = pbmi->biWidth;
				pVih->dwPictAspectRatioY = abs(pbmi->biHeight);
			}
		}else if(pamt->formattype == FORMAT_VideoInfo2){
			VIDEOINFOHEADER2 *pV2 = reinterpret_cast<VIDEOINFOHEADER2*>(pamt->pbFormat);
			pVih->dwPictAspectRatioX = pV2->dwPictAspectRatioX;
			pVih->dwPictAspectRatioY = pV2->dwPictAspectRatioY;
		}

		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::AddVIF2Flag AR_ORIG")));
		DeleteMediaType(pamt);
	}else if(m_conf.ar.ar_mode == AR_43){
		pVih->dwPictAspectRatioX = 4;
		pVih->dwPictAspectRatioY = 3;
		pVih->dwControlFlags = m_ARflag==AR_AMC ? AMCONTROL_PAD_TO_4x3 : 0;
		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::AddVIF2Flag AR_43 %d", m_ARflag==AR_AMC?1:0)));
	}else if(m_conf.ar.ar_mode == AR_169){
		pVih->dwPictAspectRatioX = 16;
		pVih->dwPictAspectRatioY = 9;
		pVih->dwControlFlags = m_ARflag==AR_AMC ? AMCONTROL_PAD_TO_16x9 : 0;
		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::AddVIF2Flag AR_169 %d", m_ARflag==AR_AMC?1:0)));
	}else if(m_conf.ar.ar_mode == AR_UD){
		pVih->dwPictAspectRatioX = m_conf.ar.ar_h;
		pVih->dwPictAspectRatioY = m_conf.ar.ar_v;
		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::AddVIF2Flag AR_UD")));
	}
	
	return S_OK;
}

// Search HWDeint in filter graph
HRESULT CHWDeintFilter::SearchHWDeint(PIN_DIRECTION dir, IPin *pPin)
{
	// returns S_OK if HWDeint does not exist
	HRESULT hr;

	if(PINDIR_OUTPUT == dir){
		return S_OK;
	}

    ASSERT(dir == PINDIR_INPUT);

	PIN_INFO    ReceivePinInfo;
	FILTER_INFO ReceiveFilterInfo;

	hr = pPin->QueryPinInfo(&ReceivePinInfo);
	if (FAILED(hr)) {
		return E_FAIL;
	}
	ReceivePinInfo.pFilter->QueryFilterInfo(&ReceiveFilterInfo);
	if (FAILED(hr)) {
		QueryPinInfoReleaseFilter(ReceivePinInfo);
		return E_FAIL;
	}

	// check filter name
	if(0==wcsncmp(ReceiveFilterInfo.achName, g_wszName, wcslen(g_wszName))) {
		//same name
		QueryFilterInfoReleaseGraph(ReceiveFilterInfo);
		QueryPinInfoReleaseFilter(ReceivePinInfo);
		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::SearchHWDeint hwdeint found.")));
		return S_FALSE;
	}
	//different name
	IEnumPins  *pEnum;
	IPin       *pPin2;
	BOOL       bFound = FALSE;
	hr = ReceivePinInfo.pFilter->EnumPins(&pEnum);
	if (FAILED(hr))
	{
		QueryFilterInfoReleaseGraph(ReceiveFilterInfo);
		QueryPinInfoReleaseFilter(ReceivePinInfo);
		return E_FAIL;
	}
	while(pEnum->Next(1, &pPin2, 0) == S_OK && !bFound)
	{
		PIN_DIRECTION PinDirThis;
		pPin2->QueryDirection(&PinDirThis);
		if (dir == PinDirThis){
			IPin *pPin3;
			if(S_OK == pPin2->ConnectedTo(&pPin3)){
				//recursive search
				hr = SearchHWDeint(dir, pPin3);
				if(S_OK != hr) bFound = TRUE;//found or an error occurd
				pPin3->Release();
			}
		}
		pPin2->Release();
	}
	pEnum->Release();

	//clean up
	QueryFilterInfoReleaseGraph(ReceiveFilterInfo);
	QueryPinInfoReleaseFilter(ReceivePinInfo);

	return hr;
}

// Check filter list in filter graph (search recursively)
HRESULT CHWDeintFilter::CheckFilter(PIN_DIRECTION dir, IPin *pPin)
{
	// returns S_OK if HWDeint does not exist
	HRESULT hr;

	if(PINDIR_OUTPUT == dir){
		return S_OK;
	}

    ASSERT(dir == PINDIR_INPUT);

	PIN_INFO    ReceivePinInfo;
	FILTER_INFO ReceiveFilterInfo;

	hr = pPin->QueryPinInfo(&ReceivePinInfo);
	if (FAILED(hr)) {
		return E_FAIL;
	}
	ReceivePinInfo.pFilter->QueryFilterInfo(&ReceiveFilterInfo);
	if (FAILED(hr)) {
		QueryPinInfoReleaseFilter(ReceivePinInfo);
		return E_FAIL;
	}

	wstring str(ReceiveFilterInfo.achName);
	// check filter name
	if(m_dsflist.end() != find(m_dsflist.begin(), m_dsflist.end(), str)) {
		QueryFilterInfoReleaseGraph(ReceiveFilterInfo);
		QueryPinInfoReleaseFilter(ReceivePinInfo);
		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::CheckFilter filter found.")));
		return E_FAIL;
	}
	//different name
	IEnumPins  *pEnum;
	IPin       *pPin2;
	BOOL       bFound = FALSE;
	hr = ReceivePinInfo.pFilter->EnumPins(&pEnum);
	if (FAILED(hr))
	{
		QueryFilterInfoReleaseGraph(ReceiveFilterInfo);
		QueryPinInfoReleaseFilter(ReceivePinInfo);
		return E_FAIL;
	}
	while(pEnum->Next(1, &pPin2, 0) == S_OK && !bFound)
	{
		PIN_DIRECTION PinDirThis;
		pPin2->QueryDirection(&PinDirThis);
		if (dir == PinDirThis){
			IPin *pPin3;
			if(S_OK == pPin2->ConnectedTo(&pPin3)){
				//recursive search
				hr = CheckFilter(dir, pPin3);
				if(S_OK != hr) bFound = TRUE;//found or an error occurd
				pPin3->Release();
			}
		}
		pPin2->Release();
	}
	pEnum->Release();

	//clean up
	QueryFilterInfoReleaseGraph(ReceiveFilterInfo);
	QueryPinInfoReleaseFilter(ReceivePinInfo);

	return hr;
}

// Check filter list (only direct connected filter)
HRESULT CHWDeintFilter::CheckFilter(IPin *pPin)
{

	// do not connect listed filters
	PIN_INFO ReceivePinInfo;
	FILTER_INFO ReceiveFilterInfo;

	if (FAILED(pPin->QueryPinInfo(&ReceivePinInfo))) {
		return E_FAIL;
	}
	if (FAILED(ReceivePinInfo.pFilter->QueryFilterInfo(&ReceiveFilterInfo))) {
		QueryPinInfoReleaseFilter(ReceivePinInfo);
		return E_FAIL;
	}

	wstring str(ReceiveFilterInfo.achName);
	// check filter name
	if(m_dsflist.end() != find(m_dsflist.begin(), m_dsflist.end(), str)) {
		QueryFilterInfoReleaseGraph(ReceiveFilterInfo);
		QueryPinInfoReleaseFilter(ReceivePinInfo);
		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::CheckFilter filter found.")));
		return E_FAIL;
	}
	QueryFilterInfoReleaseGraph(ReceiveFilterInfo);
	QueryPinInfoReleaseFilter(ReceivePinInfo);

	return S_OK;
}

// dir is the direction of our pin.
// pReceivePin is the pin we are connecting to.
HRESULT CHWDeintFilter::CompleteConnect(PIN_DIRECTION dir,IPin *pReceivePin)
{
    UNREFERENCED_PARAMETER(pReceivePin);
    ASSERT(m_pInput);
    ASSERT(m_pOutput);

    // if we are not part of a graph, then don't indirect the pointer
    // this probably prevents use of the filter without a filtergraph
    if (!m_pGraph) {
        return VFW_E_NOT_IN_GRAPH;
    }

	// Check Connecting filter
	//if(S_OK != CheckFilter(pReceivePin)) {
	//	return E_FAIL;
	//}
	if(S_OK != CheckFilter(dir, pReceivePin)) {
		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::CompleteConnect !filter")));
		return E_FAIL;
	}

	//set conversion
	m_convert = m_conf.misc.conv_upstream;

	// reconnect
    if (dir == PINDIR_OUTPUT) {
		if( m_pInput->IsConnected() ) {
			return ReconnectPin( m_pInput, &m_pInput->CurrentMediaType() );
        }
        return E_FAIL;
    }
	
    ASSERT(dir == PINDIR_INPUT);

	if(S_OK != SearchHWDeint( dir, pReceivePin )) {
		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::CompleteConnect !hwdeint")));
		return E_FAIL;
	}

	//ok
    return S_OK;

} // ComnpleteConnect


// transform
HRESULT CHWDeintFilter::Transform(IMediaSample *pDest)
{
	HRESULT hr;

	// convert mediatype
	if(UsingDifferentAllocators() && m_convert){
		CMediaType *pMT = NULL;
		hr = pDest->GetMediaType((AM_MEDIA_TYPE**)&pMT);
		if (hr == S_OK)
		{
			if(*pMT->FormatType() == FORMAT_VideoInfo){
				ConvertVideoInfoToVideoInfo2(pMT);
				AddVIF2Flag(pMT);
				pDest->SetMediaType(pMT);
				//m_pOutput->SetMediaType(pMT);
				DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::Transform UD type change")));
			}
			DeleteMediaType(pMT);
		}
	}

	//set Aspect ratio
	if(m_ARflag == AR_CHG){
		CMediaType *pMT = NULL;
		hr = pDest->GetMediaType((AM_MEDIA_TYPE**)&pMT);
		if (hr == S_OK)
		{
			if(*pMT->FormatType() == FORMAT_VideoInfo){
				ConvertVideoInfoToVideoInfo2(pMT);
				AddVIF2Flag(pMT);
			}

			VIDEOINFOHEADER2 *pvif2 = reinterpret_cast<VIDEOINFOHEADER2*>(pMT->pbFormat);
			m_ARflag = AR_AMC;

			pvif2->dwControlFlags |= AMCONTROL_USED;
			if(S_OK != m_pOutput->GetConnected()->QueryAccept(pMT)){
				pvif2->dwControlFlags = 0;
				m_ARflag = AR_STD;
				DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::Transform AMC denied w/c")));
			}

			AddVIF2Flag(pMT);
			pDest->SetMediaType(pMT);

			DeleteMediaType(pMT);

			DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::Transform AR type change")));
		}else{
			CMediaType mt(m_pOutput->CurrentMediaType());
			VIDEOINFOHEADER2 *pvif2 = reinterpret_cast<VIDEOINFOHEADER2*>(mt.pbFormat);
	
			m_ARflag = AR_AMC;
			pvif2->dwControlFlags |= AMCONTROL_USED;
			if(S_OK != m_pOutput->GetConnected()->QueryAccept(&mt)){
				pvif2->dwControlFlags = 0;
				m_ARflag = AR_STD;
				DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::Transform AMC denied")));
			}
			AddVIF2Flag(&mt);
			pDest->SetMediaType(&mt);
			//m_pOutput->SetMediaType(pMT);

			DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::Transform AR set")));
		}
	}

	//set AM_SAMPLE2_PROPERTIES
	if(m_conf.vif2.interlace && m_conf.am2.use_imedia2){
		IMediaSample2 *pms2 = NULL;
		AM_SAMPLE2_PROPERTIES prop2;

		hr = pDest->QueryInterface(IID_IMediaSample2, (void **)&pms2);
		if(S_OK == hr){
			hr = pms2->GetProperties(sizeof(AM_SAMPLE2_PROPERTIES), (PBYTE)&prop2);
			if(S_OK == hr){
				// add flags
				prop2.dwTypeSpecificFlags = AM_VIDEO_FLAG_INTERLEAVED_FRAME; //default
				if(m_conf.am2.am2_tff){
					prop2.dwTypeSpecificFlags |= AM_VIDEO_FLAG_FIELD1FIRST;
				}
				if(m_conf.am2.weave){
					prop2.dwTypeSpecificFlags |= AM_VIDEO_FLAG_WEAVE;
				}

				// convert mediatype
				if(m_convert && prop2.pMediaType){
					CMediaType mt(*prop2.pMediaType);
					if(prop2.pMediaType->formattype == FORMAT_VideoInfo){
						ConvertVideoInfoToVideoInfo2(prop2.pMediaType);
						AddVIF2Flag(prop2.pMediaType);
					}
					//m_pOutput->SetMediaType(&mt);
				}
				pms2->SetProperties(sizeof(AM_SAMPLE2_PROPERTIES), (PBYTE)&prop2);
			}
			pDest->Release();
		}else{
			DbgLog((LOG_ERROR, 3, TEXT("CHWDeintFilter::Transform get IM2IF faild")));
		}
	}

	return S_OK;
}

//util func
static bool IsSame(CFG_AR &a, CFG_AR &b)
{
	if(a.ar_h==b.ar_h && a.ar_mode==b.ar_mode && a.ar_v==b.ar_v)
		return true;

	return false;
}

//IHWDeint interfaces
STDMETHODIMP CHWDeintFilter::get_cfg(CONFIG *cfg)
{
	*cfg = m_conf;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::set_cfg(CONFIG cfg)
{
	m_ARflag = IsSame(cfg.ar, m_conf.ar) ? AR_STD : AR_CHG;
	m_conf = cfg;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::get_cfg_am2(CFG_AM2 *cfg_am2)
{
	*cfg_am2 = m_conf.am2;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::set_cfg_am2(CFG_AM2 cfg_am2)
{
	m_conf.am2 = cfg_am2;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::get_cfg_vif2(CFG_VIF2 *cfg_vif2)
{
	*cfg_vif2 = m_conf.vif2;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::get_cfg_ar(CFG_AR *cfg_ar)
{
	*cfg_ar = m_conf.ar;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::set_cfg_ar(CFG_AR cfg_ar)
{
	m_ARflag = IsSame(cfg_ar, m_conf.ar) ? AR_STD : AR_CHG;
	m_conf.ar = cfg_ar;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::get_cfg_color(int *color)
{
	*color = m_conf.colorspace;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::set_cfg_color(int color)
{
	m_conf.colorspace = color;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::get_dsflist(vector<wstring> *list)
{
	*list = m_dsflist;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::set_dsflist(const vector<wstring> *list)
{
	m_dsflist = *list;
	return S_OK;
}

