//  prop_dsf.cpp
//
//	hwdeint dsf property
//
//	Copyright (c) 2005 N099
//
#include <streams.h>     // DirectShow (includes windows.h)
#include <dvdmedia.h>
#include <commctrl.h>

#include <vector>
#include <string>
#include <algorithm>
#include <tchar.h>

#include <atlbase.h>

#include "util.h"
#include "hwdeintuids.h"
#include "hwdeint.h"

#include "prop_dsf.h"
#include "resource.h"
using namespace std;

static TCHAR col_name[] = _T("FriendlyName");

CUnknown * WINAPI CHWDeintProp_DSF::CreateInstance(LPUNKNOWN punk, HRESULT *phr)
{
    CHWDeintProp_DSF * pNewObject = new CHWDeintProp_DSF(punk);
    if (pNewObject == NULL)
	{
        *phr = E_OUTOFMEMORY;
    }
    return pNewObject;
}

CHWDeintProp_DSF::CHWDeintProp_DSF(LPUNKNOWN pUnk) :
	CBasePropertyPage(NAME("HWDeintProp_DSF"), pUnk, IDD_HWDeintProp_DSF, IDS_HWDeintProp_DSF)
	,m_pHWDeint(0), m_sort(1)
{
	/*
	INITCOMMONCONTROLSEX icex;

	icex.dwSize = sizeof(icex);
	icex.dwICC = ICC_LISTVIEW_CLASSES;

	InitCommonControlsEx(&icex);
	*/
	DbgLog((LOG_TRACE, 3, TEXT("CHWDeintProp_DSF::CHWDeintProp_DSF")));
}

void CHWDeintProp_DSF::SetDirty(void)
{
	m_bDirty = TRUE;
	if (m_pPageSite)
    {
		m_pPageSite->OnStatusChange(PROPPAGESTATUS_DIRTY);
    }
}

HRESULT CHWDeintProp_DSF::OnConnect(IUnknown *pUnk)
{
	ASSERT(m_pHWDeint == NULL);
	HRESULT hr;
	DbgLog((LOG_TRACE, 3, TEXT("CHWDeintProp_DSF::OnConnect")));
	// pUnk ŃtB^̃JX^ C^[tFCX₢킹B
	hr = pUnk->QueryInterface(IID_IHWDeint, reinterpret_cast<void**>(&m_pHWDeint));
	if(FAILED(hr)){
		return hr;
	}
	
	// ݒǂݍ
	m_newmerit = m_merit = GetMerit();

	m_pHWDeint->get_dsflist(&m_dsflist);

	return hr;
}

HRESULT CHWDeintProp_DSF::OnActivate(void)
{
    ASSERT(m_pHWDeint != NULL);

	DbgLog((LOG_TRACE, 3, TEXT("CHWDeintProp_DSF::OnActivate")));

	LVCOLUMN lvc;
	ZeroMemory(&lvc, sizeof(LVCOLUMN));

	//tB^Xg̕\
	SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_SETEXTENDEDLISTVIEWSTYLE, 
		0, LVS_EX_CHECKBOXES | LVS_EX_GRIDLINES );

	lvc.mask =LVCF_TEXT | LVCF_WIDTH;
	lvc.pszText = (LPSTR)col_name;
	lvc.cchTextMax = sizeof(col_name);
	lvc.iSubItem = 1;
	lvc.cx = 250;
	SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_INSERTCOLUMN, 0, (LPARAM)&lvc);
	ListFilters();

	//bgݒ
	TCHAR s[16];
	_sntprintf(s, sizeof(s)-1, "%.8x", m_newmerit);
	
	SendDlgItemMessage(m_Dlg, IDC_DSF_MERIT, CB_LIMITTEXT, 8, 0);
	SendDlgItemMessage(m_Dlg, IDC_DSF_MERIT, CB_ADDSTRING, 0, (LPARAM)TEXT("MERIT_PREFERRED+2"));
	SendDlgItemMessage(m_Dlg, IDC_DSF_MERIT, CB_ADDSTRING, 0, (LPARAM)TEXT("MERIT_DO_NOT_USE(default)"));
	SendDlgItemMessage(m_Dlg, IDC_DSF_MERIT, WM_SETTEXT, 0, (LPARAM)s);

    return S_OK;
}



BOOL CHWDeintProp_DSF::OnReceiveMessage(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
	{
	case WM_COMMAND:
		if (LOWORD(wParam) == IDC_DSF_CLEAR){
			ClearFilterList();
			SetDirty();
			return (LRESULT) 1;
		} else if (LOWORD(wParam) == IDC_DSF_MERIT){
			if (HIWORD(wParam) == CBN_SELENDOK) 
			{ 
				int i;
				i = SendDlgItemMessage(m_Dlg, IDC_DSF_MERIT, CB_GETCURSEL, 0, 0);
				switch (i)
				{
				case 0: // MERIT_PREFERRED+2
					m_newmerit = 0x800002;
					break;
				case 1: // MERIT_DO_NOT_USE
					m_newmerit = 0x200000;
					break;
				}
				SetDirty();
				return (LRESULT) 1;
			} else if (HIWORD(wParam) == CBN_KILLFOCUS) {
				TCHAR s[64];
				DWORD merit;
				int ret;
				//bg̓ǂݍ
				ret = SendDlgItemMessage(m_Dlg, IDC_DSF_MERIT, CB_GETCURSEL, 0, 0);
				if(CB_ERR == ret){
                    GetDlgItemText(m_Dlg, IDC_DSF_MERIT, s, 63);
					ret = _stscanf(s, "%x", &merit);
					if(ret != 1){ // lُ
						merit = m_newmerit;
					}
				}else{
					merit = m_newmerit;
				}
				_sntprintf(s, sizeof(s)-1, "%.8x", merit);
				SetDlgItemText(m_Dlg, IDC_DSF_MERIT, s);
				if( m_newmerit !=  m_merit ){
					SetDirty();
					return (LRESULT) 1;
				}
			}

			break;
		} /*else if (LOWORD(wParam) == IDC_DSF_MERIT)*/
		break;
	case WM_NOTIFY:
		if (wParam == IDC_DSF_LIST){
			switch (((NMHDR*)lParam)->code)
			{
			case LVN_COLUMNCLICK: 
				if(((NMLISTVIEW*)lParam)->iSubItem == 0){
					SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_SORTITEMSEX,
						(WPARAM)this, (LPARAM)CmpList);
					m_sort = m_sort>2 ? 0 : m_sort+1;
				}
				break;
			case LVN_KEYDOWN:
				if(((NMLVKEYDOWN*)lParam)->wVKey == VK_SPACE){
					SetDirty();
					return (LRESULT) 1;
				}
				break;
			case NM_CLICK:
				NMITEMACTIVATE *pN = (NMITEMACTIVATE*)lParam;
				if(pN->iItem != -1){
					SetDirty();
					return (LRESULT) 1;
				}
				break;
			}
		}
        break;
	}
	// eNXɃbZ[WB
    return CBasePropertyPage::OnReceiveMessage(hwnd,uMsg,wParam,lParam);
}

HRESULT CHWDeintProp_DSF::OnApplyChanges(void)
{
	TCHAR s[32];
	DWORD merit;
	int ret;
	//bg̓ǂݍ
	ret = SendDlgItemMessage(m_Dlg, IDC_DSF_MERIT, CB_GETCURSEL, 0, 0);
	if(CB_ERR == ret){
		GetDlgItemText(m_Dlg, IDC_DSF_MERIT, s, 32);
		ret = _stscanf(s, "%x", &merit);
		if(ret == 1) m_newmerit = merit;
	}
	_sntprintf(s, sizeof(s)-1, "%.8x", m_newmerit);
	SetDlgItemText(m_Dlg, IDC_DSF_MERIT, s);

	//ȃtB^̓ǂݍ
	ParseFilterList();

	m_pHWDeint->set_dsflist(&m_dsflist);

	//WXgɃZ[u
	SaveDSFlist(m_dsflist);
	if(m_newmerit != m_merit){
		m_merit = m_newmerit;
		SetMerit(m_merit);
	}

	DbgLog((LOG_TRACE, 3, TEXT("CHWDeintProp_DSF::OnApplyChanges")));

	return S_OK;
} 

HRESULT CHWDeintProp_DSF::OnDisconnect(void)
{
	DbgLog((LOG_TRACE, 3, TEXT("CHWDeintProp_DSF::OnDisconnect")));

    if (m_pHWDeint)
    {
        m_pHWDeint->Release();
        m_pHWDeint = NULL;
    }
    return S_OK;
}

//bglWXgǂ
DWORD CHWDeintProp_DSF::GetMerit(void)
{
	HKEY   hKey;
	LONG   ret;
	DWORD  size;
	DWORD  merit;
	LPBYTE buf;

	RegOpenKeyEx(HKEY_CLASSES_ROOT, HWDI_REG_SUBKEY_FINFO, 0, KEY_READ, &hKey);

	ret = RegQueryValueEx(hKey, "FilterData", NULL, NULL, NULL, &size);
	if(ret != ERROR_SUCCESS){
			RegCloseKey(hKey);
			return 0;
	}
	buf = new BYTE[size];
	if(!buf){
		RegCloseKey(hKey);
		return 0;
	}
	ret = RegQueryValueEx(hKey, "FilterData", NULL, NULL, (LPBYTE)buf, &size);
	if(ret != ERROR_SUCCESS){
		delete[] buf;
		RegCloseKey(hKey);
		return 0;
	}

	merit = reinterpret_cast<REGFILTER2*>(buf)->dwMerit;

	delete[] buf;
	RegCloseKey(hKey);
	DbgLog((LOG_TRACE, 3, TEXT("CHWDeintProp_DSF::GetMerit merit:%x"), merit));

	return merit;
}

//bgWXgɃZ[u
DWORD CHWDeintProp_DSF::SetMerit(DWORD merit)
{
	HKEY   hKey;
	LONG   ret;
	DWORD  size;
	LPBYTE buf;

	RegOpenKeyEx(HKEY_CLASSES_ROOT, HWDI_REG_SUBKEY_FINFO, 0, KEY_READ|KEY_WRITE, &hKey);

	ret = RegQueryValueEx(hKey, "FilterData", NULL, NULL, NULL, &size);
	if(ret != ERROR_SUCCESS){
			RegCloseKey(hKey);
			return 0;
	}
	buf = new BYTE[size];
		if(!buf){
		RegCloseKey(hKey);
		return 0;
	}
	ret = RegQueryValueEx(hKey, "FilterData", NULL, NULL, (LPBYTE)buf, &size);
	if(ret != ERROR_SUCCESS){
		delete[] buf;
		return 0;
	}

	reinterpret_cast<REGFILTER2*>(buf)->dwMerit = merit;
	RegSetValueEx(hKey, "FilterData", 0, REG_BINARY, buf, size);

	delete[] buf;
	RegCloseKey(hKey);
	DbgLog((LOG_TRACE, 3, TEXT("CHWDeintProp_DSF::SetMerit merit:%x"), merit));

	return merit;
}

HRESULT CHWDeintProp_DSF::ParseFilterList(void)
{
	TCHAR buf[MAX_FILTER_NAME+1];
	int item;
	LVITEM lvi;

	ZeroMemory(&lvi, sizeof(lvi));
	lvi.mask = LVIF_TEXT;
	lvi.iSubItem = 0;
	lvi.pszText = (LPSTR)buf;
	lvi.cchTextMax = MAX_FILTER_NAME;

	m_dsflist.clear();
	//ڂ̐
	item = SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_GETITEMCOUNT, 0, 0);
	DbgLog((LOG_TRACE, 3, TEXT("CHWDeintProp_DSF::ParseFilterList items:%d"), item));

	for(int i=0; i<item; ++i){
		if(ListView_GetCheckState(GetDlgItem(m_Dlg,IDC_DSF_LIST), i)){
			SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_GETITEMTEXT, i, (LPARAM)&lvi );
			CT2CW szr(buf);
			wstring str(szr);
			m_dsflist.push_back(str);
		}
	}
	unique(m_dsflist.begin(), m_dsflist.end());
	sort(m_dsflist.begin(), m_dsflist.end());

	return NOERROR;
}

HRESULT CHWDeintProp_DSF::ClearFilterList(void)
{
	int item;

	//ڂ̐
	item = SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_GETITEMCOUNT, 0, 0);
	DbgLog((LOG_TRACE, 3, TEXT("CHWDeintProp_DSF::ClearFilterList items:%d"), item));

	for(int i=0; i<item; ++i){
		ListView_SetCheckState(GetDlgItem(m_Dlg,IDC_DSF_LIST), i, FALSE);
	}

	return NOERROR;
}

HRESULT CHWDeintProp_DSF::ListFilters(void)
{
	int idx;

	// System Device Enumerator 쐬B
	HRESULT hr;
	ICreateDevEnum *pSysDevEnum = NULL;
	hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC_SERVER,
		IID_ICreateDevEnum, (void **)&pSysDevEnum);
	if (FAILED(hr))
	{
		return hr;
	}

	// DirectShow Filters JeS̃NX񋓎q擾B
	IEnumMoniker *pEnumCat = NULL;
	hr = pSysDevEnum->CreateClassEnumerator(CLSID_LegacyAmFilterCategory, &pEnumCat, 0);

	if (hr == S_OK) 
	{
		// jJ񋓂B
		IMoniker *pMoniker = NULL;
		ULONG cFetched;
		while(pEnumCat->Next(1, &pMoniker, &cFetched) == S_OK)
		{
			IPropertyBag *pPropBag;
			hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, 
				(void **)&pPropBag);
			if (SUCCEEDED(hr))
			{
				// tB^̃th擾ɂ́ȀsB
				VARIANT varName;
				VariantInit(&varName);
				hr = pPropBag->Read(L"FriendlyName", &varName, 0);
				if (SUCCEEDED(hr))
				{
					// AvP[ṼXg {bNXɒǉB
					LV_ITEM lvi_name;
					ZeroMemory(&lvi_name, sizeof(LV_ITEM));

					wstring str( varName.bstrVal );
					COLE2CT s_name( varName.bstrVal );
					lvi_name.mask = LVIF_TEXT;
					lvi_name.iSubItem = 0;
					lvi_name.pszText = s_name;
					lvi_name.cchTextMax = _tcslen(s_name);

					idx = SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_INSERTITEM,
						0, (LPARAM)&lvi_name);
					if(idx != -1)
					{
						BOOL fCheck = (m_dsflist.end() != 
							find(m_dsflist.begin(), m_dsflist.end(),str));
						ListView_SetCheckState(GetDlgItem(m_Dlg,IDC_DSF_LIST), idx, fCheck);
					}

				}
				VariantClear(&varName);

				pPropBag->Release();
			}
			pMoniker->Release();
		}
		pEnumCat->Release();
	}

	// Video Capture Sources JeS̃NX񋓎q擾B
	pEnumCat = NULL;
	hr = pSysDevEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory, &pEnumCat, 0);

	if (hr == S_OK) 
	{
		// jJ񋓂B
		IMoniker *pMoniker = NULL;
		ULONG cFetched;
		while(pEnumCat->Next(1, &pMoniker, &cFetched) == S_OK)
		{
			IPropertyBag *pPropBag;
			hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, 
				(void **)&pPropBag);
			if (SUCCEEDED(hr))
			{
				// tB^̃th擾ɂ́ȀsB
				VARIANT varName;
				VariantInit(&varName);
				hr = pPropBag->Read(L"FriendlyName", &varName, 0);
				if (SUCCEEDED(hr))
				{
					// AvP[ṼXg {bNXɒǉB
					LV_ITEM lvi_name;
					ZeroMemory(&lvi_name, sizeof(LV_ITEM));

					COLE2CT s_name( varName.bstrVal );
					wstring str( varName.bstrVal );
					lvi_name.mask = LVIF_TEXT;
					lvi_name.iSubItem = 0;
					lvi_name.pszText = s_name;
					lvi_name.cchTextMax = _tcslen(s_name);

					idx = SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_INSERTITEM,
						0, (LPARAM)&lvi_name);
					if(idx != -1)
					{
						BOOL fCheck = (m_dsflist.end() != 
							find(m_dsflist.begin(), m_dsflist.end(), str));
						ListView_SetCheckState(GetDlgItem(m_Dlg,IDC_DSF_LIST), idx, fCheck);
					}
				}
				VariantClear(&varName);

				pPropBag->Release();
			}
			pMoniker->Release();
		}
		pEnumCat->Release();
	}
	pSysDevEnum->Release();

	return hr;
}

// list sort function
int CALLBACK CmpList(LPARAM lP1, LPARAM lP2, LPARAM lPS)
{
	int ret = 0;
	CHWDeintProp_DSF *cdd = (CHWDeintProp_DSF *)lPS;

	if(cdd->m_sort > 1){
		bool b0, b1;
		b0 = ListView_GetCheckState(GetDlgItem(cdd->m_Dlg,IDC_DSF_LIST), lP1);
		b1 = ListView_GetCheckState(GetDlgItem(cdd->m_Dlg,IDC_DSF_LIST), lP2);
		if(b0!=b1){
			ret = b0 ? -1 : 1;
		}
	}
	if(ret == 0){
		TCHAR buf0[MAX_FILTER_NAME+1];
		TCHAR buf1[MAX_FILTER_NAME+1];
		LVITEM lvi0;
		LVITEM lvi1;

		ZeroMemory(&lvi0, sizeof(lvi0));
		ZeroMemory(buf0, sizeof(buf0));
		lvi0.mask = LVIF_TEXT;
		lvi0.iSubItem = 0;
		lvi0.pszText = (LPSTR)buf0;
		lvi0.cchTextMax = MAX_FILTER_NAME;
		ZeroMemory(&lvi1, sizeof(lvi1));
		ZeroMemory(buf1, sizeof(buf1));
		lvi1.mask = LVIF_TEXT;
		lvi1.iSubItem = 0;
		lvi1.pszText = (LPSTR)buf1;
		lvi1.cchTextMax = MAX_FILTER_NAME;

		SendDlgItemMessage(cdd->m_Dlg, IDC_DSF_LIST, LVM_GETITEMTEXT, lP1, (LPARAM)&lvi0 );
		SendDlgItemMessage(cdd->m_Dlg, IDC_DSF_LIST, LVM_GETITEMTEXT, lP2, (LPARAM)&lvi1 );

		ret = _tcsicmp(buf0, buf1);
	}

	return cdd->m_sort&1 ? -ret : ret;
}

