//  util.cpp
//
//	reg utility functions
//
//	Copyright (c) 2005 N099
//
#include <windows.h>
#include <streams.h>

#include <vector>
#include <string>
#include <algorithm>
#include <tchar.h>
#include <atlbase.h>

#include "hwdeintdefs.h"
#include "util.h"
using namespace std;


void LoadRegistryInfo(CONFIG *conf)
{
	HKEY hKey;
	DWORD val;
	DWORD size = sizeof(DWORD);
	LONG ret;
	RegOpenKeyEx(HWDI_REG_KEY, HWDI_REG_SUBKEY, 0, KEY_READ, &hKey);
 

	ret = RegQueryValueEx(hKey, "VIF2_interlace", NULL, NULL, (LPBYTE)&val, &size);
	conf->vif2.interlace = (ret != ERROR_SUCCESS) ? 0 : val;

	ret = RegQueryValueEx(hKey, "VIF2_tff", NULL, NULL, (LPBYTE)&val, &size);
	conf->vif2.vif_tff = (ret != ERROR_SUCCESS) ? 0 : val;

	ret = RegQueryValueEx(hKey, "VIF2_disp_mode", NULL, NULL, (LPBYTE)&val, &size);
	conf->vif2.disp_mode = (ret != ERROR_SUCCESS) ? 0 : val;

	ret = RegQueryValueEx(hKey, "AM2_use_imedia2", NULL, NULL, (LPBYTE)&val, &size);
	conf->am2.use_imedia2 = (ret != ERROR_SUCCESS) ? 0 : val;

	ret = RegQueryValueEx(hKey, "AM2_tff", NULL, NULL, (LPBYTE)&val, &size);
	conf->am2.am2_tff = (ret != ERROR_SUCCESS) ? 0 : val;

	ret = RegQueryValueEx(hKey, "AM2_weave", NULL, NULL, (LPBYTE)&val, &size);
	conf->am2.weave = (ret != ERROR_SUCCESS) ? 0 : val;
	
	ret = RegQueryValueEx(hKey, "AR_mode", NULL, NULL, (LPBYTE)&val, &size);
	conf->ar.ar_mode = (ret != ERROR_SUCCESS) ? AR_ORIG	: val;

	ret = RegQueryValueEx(hKey, "AR_h", NULL, NULL, (LPBYTE)&val, &size);
	conf->ar.ar_h = (ret != ERROR_SUCCESS) ? AR_H_DEF : val;

	ret = RegQueryValueEx(hKey, "AR_v", NULL, NULL, (LPBYTE)&val, &size);
	conf->ar.ar_v = (ret != ERROR_SUCCESS) ? AR_V_DEF : val;

	ret = RegQueryValueEx(hKey, "ShowTrayIcon", NULL, NULL, (LPBYTE)&val, &size);
	conf->misc.tray = (ret != ERROR_SUCCESS) ? 1 : val;

	ret = RegQueryValueEx(hKey, "cnv_upstream", NULL, NULL, (LPBYTE)&val, &size);
	conf->misc.conv_upstream = (ret != ERROR_SUCCESS) ? 1 : val;

	ret = RegQueryValueEx(hKey, "not_connect_i", NULL, NULL, (LPBYTE)&val, &size);
	conf->misc.not_connect_iflg = (ret != ERROR_SUCCESS) ? 1 : val;

	ret = RegQueryValueEx(hKey, "colorspace", NULL, NULL, (LPBYTE)&val, &size);
	conf->colorspace = (ret != ERROR_SUCCESS) ? TYPE_ALL : val;


	RegCloseKey(hKey);
}

void SaveRegistryInfo(CONFIG &conf)
{
	HKEY hKey;
	DWORD dispo, val;

	if (RegCreateKeyEx(
			HWDI_REG_KEY,
			HWDI_REG_SUBKEY,
			0,
			HWDI_REG_CLASS,
			REG_OPTION_NON_VOLATILE,
			KEY_WRITE,
			0, 
			&hKey, 
			&dispo) != ERROR_SUCCESS)
	{
		OutputDebugString(NAME("SaveRegistryInfo:Couldn't create HWDI_REG_SUBKEY"));
		return;
	}

	// check value & save
	val = conf.vif2.interlace;
	RegSetValueEx(hKey, "VIF2_interlace", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.vif2.vif_tff;
	RegSetValueEx(hKey, "VIF2_tff", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.vif2.disp_mode;
	RegSetValueEx(hKey, "VIF2_disp_mode", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.am2.use_imedia2;
	RegSetValueEx(hKey, "AM2_use_imedia2", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.am2.am2_tff;
	RegSetValueEx(hKey, "AM2_tff", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.am2.weave;
	RegSetValueEx(hKey, "AM2_weave", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.ar.ar_mode;
	RegSetValueEx(hKey, "AR_mode", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.ar.ar_h;
	RegSetValueEx(hKey, "AR_h", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.ar.ar_v;
	RegSetValueEx(hKey, "AR_v", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.misc.tray;
	RegSetValueEx(hKey, "ShowTrayIcon", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.misc.conv_upstream;
	RegSetValueEx(hKey, "cnv_upstream", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.misc.not_connect_iflg;
	RegSetValueEx(hKey, "not_connect_i", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.colorspace;
	RegSetValueEx(hKey, "colorspace", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));


	RegCloseKey(hKey);
}

void LoadDSFlist(vector<wstring> &list)
{
	HKEY  hKey;
	DWORD size;
	DWORD type;
	LONG  ret = ERROR_SUCCESS;
	TCHAR s[16];
	BYTE *buf;

	RegOpenKeyEx(HWDI_REG_KEY, HWDI_REG_SUBKEY_DSF, 0, KEY_READ, &hKey);

	list.clear();

	for(int i=0; ret==ERROR_SUCCESS; ++i){
		_stprintf(s, "D%.3d", i);
		ret = RegQueryValueEx(hKey, s, NULL, &type, NULL, &size);
		if(ret == ERROR_SUCCESS && type == REG_SZ){
			buf = new BYTE[size];
			if(!buf) break;
			ret = RegQueryValueEx(hKey, s, NULL, NULL, (LPBYTE)buf, &size);
			if(ret == ERROR_SUCCESS){
				CT2CW c((LPCTSTR)buf);
				wstring str(c);
				list.push_back(str);
			}
			delete[] buf;
		}
	}
	unique(list.begin(), list.end());
	sort(list.begin(), list.end());

	DbgLog((LOG_TRACE, 3, TEXT("LoadDSFlist:Loaded %d DSFs"), i-1));

	RegCloseKey(hKey);
}

void SaveDSFlist(vector<wstring> &list)
{
	HKEY hKey;
	DWORD dispo;
	TCHAR s[16];
	BYTE buf[MAX_FILTER_NAME*sizeof(TCHAR)];
	LONG  ret = ERROR_SUCCESS;
	int i;

	if (RegCreateKeyEx(
			HWDI_REG_KEY,
			HWDI_REG_SUBKEY_DSF,
			0,
			HWDI_REG_CLASS,
			REG_OPTION_NON_VOLATILE,
			KEY_WRITE,
			0, 
			&hKey, 
			&dispo) != ERROR_SUCCESS)
	{
		OutputDebugString(NAME("SaveDSFlist:Couldn't create HWDI_REG_SUBKEY_DSF"));
		return;
	}

	// clear all entries
	for(i=0; ret==ERROR_SUCCESS; ++i){
		_stprintf(s, "D%.3d", i);
		ret = RegDeleteValue(hKey, s);
	}
	i = 0;

	// save list
	vector<wstring>::iterator p = list.begin();
	while(p != list.end()){
		_stprintf(s, "D%.3d", i);
		CW2CT c(p->c_str());
		_tcsncpy((TCHAR *)buf, c, MAX_FILTER_NAME);
		RegSetValueEx(hKey, s, 0, REG_SZ, (const BYTE*)buf, _tcslen((LPCTSTR)buf)+1);
		++i;
		++p;
		if(i>100) break; //max 100 for safe
	}

	DbgLog((LOG_TRACE, 3, NAME("SaveDSFlist:Saved %d DSFs"), i));

	RegCloseKey(hKey);
}


